version: '3'

services:
  gitlab-runner:
    image: gitlab/gitlab-runner:latest
    restart: always
    mem_limit: 512m
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock
      - ./config:/etc/gitlab-runner

  oneshot-gitlab-runner-register:
    image: gitlab/gitlab-runner:latest
    entrypoint: |
      /bin/bash -c '
        gitlab-runner register \
        --non-interactive \
        --name "my gitlab runner" \
        --url "${GITLAB_URL}" \
        --registration-token "${GITLAB_RUNNER_ACCESS_TOKEN}" \
        --clone-url "${GITLAB_URL}" \
        --docker-volumes "/var/run/docker.sock:/var/run/docker.sock" \
        --locked="false" \
        --executor="docker" \
        --docker-privileged="true" \
        --paused="true" \
        --docker-cpus="1" \
        --docker-image="docker:stable" \
        --run-untagged="true"
      '
    volumes:
      - ./config:/etc/gitlab-runner
    environment:
      - GITLAB_URL=${GITLAB_URL}
      - GITLAB_RUNNER_ACCESS_TOKEN=${GITLAB_RUNNER_ACCESS_TOKEN}
